package dev.shadowsoffire.apotheosis.potion.compat;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.potion.PotionCharmItem;
import dev.shadowsoffire.apotheosis.potion.PotionCharmRecipe;
import dev.shadowsoffire.apotheosis.potion.compat.PotionJEIPlugin;
import it.unimi.dsi.fastutil.ints.IntListIterator;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.function.Supplier;
import java.util.stream.Collectors;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.ingredient.ICraftingGridHelper;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.ingredients.ITypedIngredient;
import mezz.jei.api.recipe.IFocus;
import mezz.jei.api.recipe.IFocusGroup;
import mezz.jei.api.recipe.category.extensions.vanilla.crafting.ICraftingCategoryExtension;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.alchemy.Potion;
import net.minecraft.world.item.alchemy.PotionUtils;
import net.minecraft.world.item.alchemy.Potions;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.level.ItemLike;
import net.minecraftforge.registries.ForgeRegistries;

class PotionCharmRecipeWrapper implements ICraftingCategoryExtension {
  private final PotionCharmRecipe recipe;
  
  PotionCharmRecipeWrapper(PotionCharmRecipe recipe) {
    this.recipe = recipe;
  }
  
  public ResourceLocation getRegistryName() {
    return this.recipe.m_6423_();
  }
  
  public int getWidth() {
    return 3;
  }
  
  public int getHeight() {
    return 3;
  }
  
  public void setRecipe(IRecipeLayoutBuilder builder, ICraftingGridHelper craftingGridHelper, IFocusGroup focuses) {
    Potion potion = PotionUtils.m_43579_(focuses.getFocuses((IIngredientType)VanillaTypes.ITEM_STACK).findFirst().map(IFocus::getTypedValue).map(ITypedIngredient::getIngredient).orElse(ItemStack.f_41583_));
    List<List<ItemStack>> recipeInputs = (List<List<ItemStack>>)this.recipe.m_7527_().stream().map(i -> Arrays.asList(i.m_43908_())).collect(Collectors.toCollection(ArrayList::new));
    if (potion != Potions.f_43598_)
      for (IntListIterator<Integer> intListIterator = this.recipe.getPotionSlots().iterator(); intListIterator.hasNext(); ) {
        int i = ((Integer)intListIterator.next()).intValue();
        recipeInputs.set(i, Arrays.asList(new ItemStack[] { PotionUtils.m_43549_(new ItemStack((ItemLike)Items.f_42589_), potion) }));
      }  
    ItemStack output = new ItemStack((ItemLike)Apoth.Items.POTION_CHARM.get());
    PotionUtils.m_43549_(output, potion);
    craftingGridHelper.createAndSetInputs(builder, (IIngredientType)VanillaTypes.ITEM_STACK, recipeInputs, getWidth(), getHeight());
    if (potion != Potions.f_43598_) {
      craftingGridHelper.createAndSetOutputs(builder, (IIngredientType)VanillaTypes.ITEM_STACK, Arrays.asList(new ItemStack[] { output }));
    } else {
      List<ItemStack> potionStacks = new ArrayList<>();
      for (Potion p : ForgeRegistries.POTIONS) {
        if (!PotionCharmItem.isValidPotion(p))
          continue; 
        ItemStack charm = new ItemStack((ItemLike)Apoth.Items.POTION_CHARM.get());
        PotionUtils.m_43549_(charm, p);
        potionStacks.add(charm);
      } 
      craftingGridHelper.createAndSetOutputs(builder, (IIngredientType)VanillaTypes.ITEM_STACK, potionStacks);
    } 
  }
}
